Index: plugins/check_ntp_peer.c
===================================================================
--- plugins/check_ntp_peer.c	(revision 1863)
+++ plugins/check_ntp_peer.c	(revision 1865)
@@ -264,7 +264,8 @@
 		/* Attempt to read the largest size packet possible */
 		req.count=htons(MAX_CM_SIZE);
 		DBG(printf("recieving READSTAT response"))
-		read(conn, &req, SIZEOF_NTPCM(req));
+		if(read(conn, &req, SIZEOF_NTPCM(req)) == -1)
+			die(STATE_CRITICAL, "NTP CRITICAL: No response from NTP server\n");
 		DBG(print_ntp_control_message(&req));
 		/* Each peer identifier is 4 bytes in the data section, which
 	 	 * we represent as a ntp_assoc_status_pair datatype.
Index: plugins/t/check_ntp.t
===================================================================
--- plugins/t/check_ntp.t	(revision 1863)
+++ plugins/t/check_ntp.t	(revision 1865)
@@ -97,13 +97,13 @@
 		like( $res->output, $ntp_okmatch2, "$plugin: Output match OK with jitter and stratum" );
 
 		$res = NPTest->testCmd(
-			"./$plugin -H $ntp_service -w 1000 -c 2000 -W ~:-1 -C 21 -j 100000 -k 200000"
+			"./$plugin -H $ntp_service -w 1000 -c 2000 -W \\~:-1 -C 21 -j 100000 -k 200000"
 			);
 		cmp_ok( $res->return_code, '==', 1, "$plugin: Warning NTP result with jitter and stratum check" );
 		like( $res->output, $ntp_warnmatch2, "$plugin: Output match WARNING with jitter and stratum" );
 
 		$res = NPTest->testCmd(
-			"./$plugin -H $ntp_service -w 1000 -c 2000 -W 20 -C 21 -j 100000 -k ~:-1"
+			"./$plugin -H $ntp_service -w 1000 -c 2000 -W 20 -C 21 -j 100000 -k \\~:-1"
 			);
 		cmp_ok( $res->return_code, '==', 2, "$plugin: Critical NTP result with jitter and stratum check" );
 		like( $res->output, $ntp_critmatch2, "$plugin: Output match CRITICAL with jitter and stratum" );
